<?php

declare(strict_types=1);

namespace Imi\Server\Http\Message\Proxy;

use Imi\RequestContextProxy\Annotation\RequestContextProxy;
use Imi\RequestContextProxy\BaseRequestContextProxy;
use Imi\Util\Socket\IPEndPoint;

/**
 * @RequestContextProxy(class="Imi\Server\Http\Message\Contract\IHttpRequest", name="request")
 *
 * @method static mixed getCookie(string $name, $default = NULL)
 * @method static setCookieParams(array $cookies)
 * @method static static setCookieParams(array $cookies)
 * @method static setQueryParams(array $query)
 * @method static static setQueryParams(array $query)
 * @method static setUploadedFiles(array $uploadedFiles)
 * @method static static setUploadedFiles(array $uploadedFiles)
 * @method static setParsedBody($data)
 * @method static static setParsedBody($data)
 * @method static setAttribute(string $name, $value)
 * @method static static setAttribute(string $name, $value)
 * @method static removeAttribute(string $name)
 * @method static static removeAttribute(string $name)
 * @method static mixed get(?string $name = NULL, $default = NULL)
 * @method static mixed post(?string $name = NULL, $default = NULL)
 * @method static bool hasGet(string $name)
 * @method static bool hasPost(string $name)
 * @method static mixed request(?string $name = NULL, $default = NULL)
 * @method static bool hasRequest(string $name)
 * @method static withGet(array $get)
 * @method static static withGet(array $get)
 * @method static setGet(array $get)
 * @method static static setGet(array $get)
 * @method static withPost(array $post)
 * @method static static withPost(array $post)
 * @method static setPost(array $post)
 * @method static static setPost(array $post)
 * @method static withRequest(array $request)
 * @method static static withRequest(array $request)
 * @method static setRequest(array $request)
 * @method static static setRequest(array $request)
 * @method static array getServerParams()
 * @method static array getCookieParams()
 * @method static withCookieParams(array $cookies)
 * @method static static withCookieParams(array $cookies)
 * @method static array getQueryParams()
 * @method static withQueryParams(array $query)
 * @method static static withQueryParams(array $query)
 * @method static array getUploadedFiles()
 * @method static withUploadedFiles(array $uploadedFiles)
 * @method static static withUploadedFiles(array $uploadedFiles)
 * @method static array|object|null getParsedBody()
 * @method static withParsedBody($data)
 * @method static static withParsedBody($data)
 * @method static array getAttributes()
 * @method static mixed getAttribute($name, $default = NULL)
 * @method static withAttribute($name, $value)
 * @method static static withAttribute($name, $value)
 * @method static withoutAttribute($name)
 * @method static static withoutAttribute($name)
 * @method static string getRequestTarget()
 * @method static withRequestTarget($requestTarget)
 * @method static static withRequestTarget($requestTarget)
 * @method static string getMethod()
 * @method static withMethod($method)
 * @method static static withMethod($method)
 * @method static UriInterface getUri()
 * @method static withUri(\Psr\Http\Message\UriInterface $uri, $preserveHost = false)
 * @method static static withUri(\Psr\Http\Message\UriInterface $uri, $preserveHost = false)
 * @method static string getProtocolVersion()
 * @method static withProtocolVersion($version)
 * @method static static withProtocolVersion($version)
 * @method static string[][] getHeaders()
 * @method static bool hasHeader($name)
 * @method static string[] getHeader($name)
 * @method static string getHeaderLine($name)
 * @method static withHeader($name, $value)
 * @method static static withHeader($name, $value)
 * @method static withAddedHeader($name, $value)
 * @method static static withAddedHeader($name, $value)
 * @method static withoutHeader($name)
 * @method static static withoutHeader($name)
 * @method static \Psr\Http\Message\StreamInterface getBody()
 * @method static withBody(\Psr\Http\Message\StreamInterface $body)
 * @method static static withBody(\Psr\Http\Message\StreamInterface $body)
 * @method static setRequestTarget($requestTarget)
 * @method static static setRequestTarget($requestTarget)
 * @method static setMethod(string $method)
 * @method static static setMethod(string $method)
 * @method static setUri(\Psr\Http\Message\UriInterface $uri, bool $preserveHost = false)
 * @method static static setUri(\Psr\Http\Message\UriInterface $uri, bool $preserveHost = false)
 * @method static IPEndPoint getClientAddress()
 */
class RequestProxy extends BaseRequestContextProxy
{
}
